// Pour compiler [mac, linux]:
// g++ premiers.cpp -o premiers
// Pour executer [mac, linux]:
// ./premiers
#include <iostream>
#include <cmath>
using namespace std;
const int N = 1000000000; // combien de nombres nous interessent

void afficher(bool* premiers) {
   for (int k = 0; k < N; k++) {
        if (premiers[k]) cout << k << endl;
   }
}

void afficher_vm(double *vm) {
   for (int k = 0; k < N; k++) cout << vm[k] << endl;
}

int fonction_pi(bool* premiers, int x) {
   int compteur = 0;
   for (int i = 0; i < x; i++) {
       if (premiers[i]) compteur++;
   }
   return compteur;
}

double fonction_tch(double * vm, int x) {
   double somme = 0.0;
   for (int i = 0; i < x; i++) {
      somme += vm[i];
   }
   return somme;
}

int main(int argc, char** argv) {
    bool* premiers = new bool[N];
    double* vm = new double[N];
    premiers[0] = premiers[1] = false;
    for (int i = 0; i < N; i++) vm[i] = 0.0;
    for (int k = 2; k < N; k++) premiers[k] = true;
    for (int k = 2; k < N; k++) {
        if (premiers[k]) { // on a trouve un premier
            for (int j = 2; j * k < N; j++) { // elimine tous les multiples du premier
                premiers[j * k] = false;
            }
            int puissance_k = k;
            for (int i = 1; i <= log(N) / log(k); i++) {
                 vm[puissance_k] = log(k);
                 puissance_k *= k;
            }
        }
    }

    cout << fonction_tch(vm, 10) << endl;
//    afficher(premiers);
//    afficher_vm(vm);

    int x = 10;
    int z = (int) (log(N+1) / log(10));
    cout << "Fonction pi" << endl;
    for (int j = 0; j < z; j++) {
        cout << fonction_pi(premiers, x) << " vs " << x / log(x)  << endl;
        x *= 10;
    }
    cout << "Fonction Tchebytchev" << endl;
     x = 10;
     for (int j = 0; j < z; j++) {
       double tch = fonction_tch(vm, x);
       cout << tch << " vs " << x << " (diff=" << tch - x << ")" << endl;
       x *= 10;
    }
    return 0;
}
